// MatrixSize.cpp : implementation file
//

#include "stdafx.h"
#include "Color.h"
#include "MatrixSize.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MatrixSize dialog


MatrixSize::MatrixSize(CWnd* pParent /*=NULL*/)
	: CDialog(MatrixSize::IDD, pParent)
{
	//{{AFX_DATA_INIT(MatrixSize)
	m_mode = -1;
	m_size1 = 0;
	m_size2 = 0;
	m_fix = FALSE;
	//}}AFX_DATA_INIT
}


void MatrixSize::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MatrixSize)
	DDX_Radio(pDX, IDC_RADIO1, m_mode);
	DDX_Text(pDX, IDC_EDIT1, m_size1);
	DDV_MinMaxInt(pDX, m_size1, 5, 50);
	DDX_Text(pDX, IDC_EDIT2, m_size2);
	DDV_MinMaxInt(pDX, m_size2, 30, 800);
	DDX_Control(pDX, IDC_BUTTON1, m_wndColor1);
	DDX_Control(pDX, IDC_BUTTON2, m_wndColor2);
	DDX_Control(pDX, IDC_BUTTON3, m_wndColor3);
	DDX_Check(pDX, IDC_CHECK, m_fix);
	//}}AFX_DATA_MAP
	DDX_FODropColorButton(pDX,IDC_BUTTON1,color1);
	DDX_FODropColorButton(pDX,IDC_BUTTON2,color2);
	DDX_FODropColorButton(pDX,IDC_BUTTON3,color3);
}


BEGIN_MESSAGE_MAP(MatrixSize, CDialog)
	//{{AFX_MSG_MAP(MatrixSize)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MatrixSize message handlers
