// Nucleus.cpp: implementation of the Nucleus class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Color.h"
#include "Nucleus.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define at(a,b) a+b*size

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#define MASK_INIT 0
#define MASK_WORK 1
#define MASK_DONE 2
#define MASK_NULL 3
#define MASK_SHOOT 4


Nucleus::Nucleus()
{
}

Nucleus::~Nucleus()
{
}

/*void Nucleus::AddRules(char reason,WORD x,WORD y=0)
//{
}

//        

WORD Nucleus::GetTopsQuantity(WORD n)
{
	WORD q=0;
	for(WORD m=0; m<tops.GetSize(); m++) { if(!tmask[n] && tops.Get(n,m)) q++; }
	return q;
}






void Nucleus::DelLink(WORD n)
{
	lmask[n]=true;
	CPoint point graph->GetLINKs(n);
	tops.Set(point,-1); tquantity[point.x]--;
	for(WORd m=0; m<link.GetSize(); m++) { if(matrix.GetTop(n,m)) lquantity[m]--;}
}


WORD Nucleus::GetConnectLink(WORD n)
{
	for(WORD m=0; m<matrix.GetSize(); m++) {if(matrix.Get(n,m) && !lmask[n]) return m;}
	return -1;
}

WORD Nucleus::GetConnectTop(WORD n)
{
	for(WORD m=0; m<tops.GetSize(); m++) {if(tops.Get(n,m) && !tmask[n]) return m;}
	return -1;
}


matrix		//   ( )
tops		//   ()
counts		//  
tconnt		//  


//  ....  
/*
void Optimize_recall()
{
	for(n=0; n<HeuristicCount; n++)
	{
		WORD x=HeuristicStack[n].x;
		WORD y=HeuristicStack[n].y;
		switch(HeuristicStack[n])
		case shoot:
			for(color=
		case dual:


		case copy:
		case linear:
		case shain:
	}
}


bool Optimize_shoot()
{
	int x,y,z; bool res=false; int size=tops.GetSize();
	for(int x=0; x<size; x++) {
	if(tcount[x]==1) for(int y=0; y<size; y++)
	if(tcount[y]==2 && (z=tops.Get(x,y))!=-1) DeleteLink(z),AddHeuristic(Shoot,z),res=true;}
	return res;
}

bool Optimize_dual()
{
	int size=matrix.GetSize(); bool res=false;
	for(x=0; x<size; x++)
	{
		if(!counts[x]) continue;
		for(y=x+1; y<size; y++)
		{
			for(z=0; z<size; z++) if(z==x || z==y || matrix.Get(x,z)==matrix.Get(y,z)) continue;
			if(z==size) DeleteLink(y),AddHeurtic(Dual,y,x),res=true;
		}
	}
}


bool Optimize_fill(BitMap *exlude,WORD from,WORD to)
{
	WORD temp; bool res;
	if(from==to) return true;
	for(WORD n=0; n<mask->GetSize(); n++)
	{
		WORD temp=tops.Get(from,n);
		if(map(n) && temp!=-1)
		{
			tops.Set(from,to,-1); res=Optimize_fill(n,to); tops.Set(from,to,temp);
			if(res) exclude->Ret(temp), return true;
		}
	}
	return false;
}



bool Optimize_linear()
{
	int size=tops.GetSize(); BitMap map(matrix.GetSize());	bool res=false;
	map.Fill();
	for(WORD x=0; x<size; x++)
	for(WORD y=0; y<size; y++)
	{
		WORD temp=tops.Get(x,y);
		if(temp!=-1 && map.Get(temp)) tops.Set(x,y,-1);
		if(Optimize_fill(*map,x,y)) tops.Set(x,y,temp);
		else AddHeuristic(Linear,x,y), DeleteLink(temp) res=true;
	}
	delete[]map; return res;
}








//bool Nucleus::Empty()
//{
//	bool res=false;
//	for(int n=0; n<matrix.GetSize(); n++)
//	{
//		if(!lmask[n] && !lquantity[n]) Del(n),res=true;
//	}
//	return res;
//}

bool Nucleus::optimize_Shoot()
{
	WORD n,m; bool res=false;
	for(n=0; n<matrix.GetSize(); n++)
	{
		if(!lmask[n] && lquantity[n]==1) {
			WORD m=GetConnetedLink(n);
			if(!lmask[m] && lquantity[n]>1) AddRules(shoot,n,m),DelLink(n),res=true;
		}
	}
	return res;
}

void Nucleus::optimize_Shain()
{
	bool res=false;
	for(WORD n=0; n<tops.GetSize(); n++)
	{
		if(tquantity[n]==2 && !tmask[m]) for(WORD m=0; m<matrix.GetSize(); m++)
		{
			if(tmask[m] || tquantity[m]!=2 || tops.Get(n,m)!=-1) continue;
			res=true;
			WORD ln=tops.Get(n,m); DelLink(n,m);
			WORD a=GetConnectedTop(n); WORD b=GeyConnectedTop(m);
			WORD la=tops.Get(a,n), lb=tops.Get(m,b); DelLink(lb);
			tops.Set(a,n,false);
			tops.Set(a,b,true);
			matrix.Set(la,ln,false); 
			AddRules(copy,lb,la); AddRules(shain,lb,la);
			for(WORD x=0; x<tops.GetSize(); x++)
			{
				y=tops.Get(b,n); if(y>=0)matrix.Set(la,y,true);
			}
			lquantity[a]+=lquatity[b];
		}
	}	
	return res;
}		

//   

bool Nucleus::optimize_Dual()
{
	for(WORD n=0; n<matrix.GetSize(); n++) 
	{
		if(!lmask[n]) for(WORD m=0; matrix.GetSize(); m++)
		{
			



		}
	}

}

//   
// 



//    

void Nucleus::Remove(int n)
{
/*	bool *in,*out; in=out=matrix;
	for(int a=0; a<size; a++)
		for(int b=0; b<size; b++)
		{
			if(a!=n && b!=n) *out++=*in;
			in++;
		}
	size--;

}
8?
//   

void Nucleus::EstimateSub(int n, int depth)
{
/*
	buffer[depth]=n; int m;
	for(m=0; m<depth; m++)
	{
		if(buffer[m]==n) continue;
		if(!matrix[at(n,m)] || !matrix[at(m,n)]) return;
	}
	depth++; if(depth>estimate) estimate=depth; 
	for(m=n+1; m<size; m++)
	{
		EstimateSub(m,depth);
	}
}

//  

void Nucleus::Estimate()
{
	/*
	estimate=0;
	buffer=new(int[size]);
	EstimateSub(0,0);
	delete[]buffer;

}

//   

bool Nucleus::CMPpropert(int a, int b)
{
	for(int n=0; n<size; n++)
	{
		if(n==a||n==b||skip[n]) continue;
		if(matrix[at(a,n)] != matrix[at(b,n)]) return false;
	}
	return true;
}

//     

void Nucleus::FindPropert()
{
	int a,b;
	a=size;
	while(a--)
	{
		if(skip[a]) continue;
		for(b=0; b<a; b++)
		{
			if(!skip[b] && CMPpropert(a,b)) { skip[b]=true; break;}
		}
	}
}
8?*/

void Nucleus::FindSub(int depth)
{
	int n,m;
	if(depth==matrix.GetSize())
	{
		for(n=m=0; n<matrix.GetSize(); n++) { if(buffer[n]>m) m=buffer[n]; }
		if (m<MinColors) { memcpy(result,buffer,depth*sizeof(WORD)); MinColors=m; }
		return;
	}
	for(n=0; n<=depth; n++)
	{
		if(n==MinColors) break;
		for(m=0; m<depth; m++) 
		{ 
			if(matrix.Get(m,depth) && buffer[m]==n) break;
		}
		if(m<depth) continue;
		buffer[depth]=n;
		FindSub(depth+1);
//		if(MinColors==estimate) return;
	}
}

//    

void Nucleus::Start(Graph *gr)
{
	if(gr->GetLINKs()==4) 
	 MessageBox(0,0,0,0); ;
    int n,m,a,b,x,y; CPoint point; graph=gr;
	int lsize=graph->GetLINKs(); int tsize=graph->GetTOPs();
	NumberMatrix topMatrix(tsize,(BYTE)-1);	//   
	for(n=0; n<lsize; n++) topMatrix.Set(graph->GetLINK(n),n);	//   

	for(y=0; y<tsize; y++) {
		for(x=0; x<tsize; x++) {
			TRACE(" %d",(int)topMatrix.Get(x,y));
		} TRACE("\n");
	}

	enum topStat{undef,work,done}*mask;	mask=new(topStat[tsize]);
	for(x=0; x<tsize; x++)
	{
		for(y=0; y<tsize; y++) {if(topMatrix.Get(x,y)!=0xffff) break;}
		if(y==tsize) mask[x]=done; else mask[x]=undef;
	}

	int first,last; // first last       (     ...)
	for(;;) {	//   (     )
	for(first=0; first<tsize; first++) {if(mask[first]==undef) break;}	if(first==tsize) return;
	mask[first]=work; if(first>=tsize) return; last=first;
//	log=*log_=new Report::ItemST; memset(log,0,sizeof(Report::ItemST)); 
	n=0; bool loop;		//    
	do{
		loop=false;
		for(x=0; x<tsize; x++) 
		{
			if (mask[x]!=work) continue;
			for(y=0; y<tsize; y++) 
			{ 
				if(mask[y]==undef && topMatrix.Get(x,y)!=0xffff) 
				{
					mask[y]=work;
					n++;
					loop=true;
					if(y+1>last) last=y+1;
				}
			}
		}
	}while(loop);
//	log->tops=n;

	n=0;			//       
	for(y=first; y<last; y++) 
	{
		if(mask[y]!=work) continue;
		for(x=y+1; x<last; x++) { if (mask[x]==work && topMatrix.Get(x,y)!=0xffff) n++;}
		a++;
	}
	if(!n) {MessageBox(0,"Internal error 1",0,0); return;}
	matrix.Install(n,0);
//	log->links=n; 

	numbers=new(WORD[tsize]);	//      
	WORD *back=new(WORD[lsize]);


	n=0;
	for(y=first; y<last; y++) 
	{
		if(mask[y]!=work) continue;
		for(x=y+1;x<last; x++)
		{
			m=topMatrix.Get(x,y);
			if(mask[x]==work && m!=0xffff) back[m]=n,numbers[n++]=m;
		}
	}
// numbers     
// back       numbers

	for(n=0; n<tsize; n++) { if(mask[n]!=work) continue;	//   
	for(a=0; a<tsize; a++) { WORD x=topMatrix.Get(n,a); if(x==0xffff) continue;
	for(b=0; b<tsize; b++) {
		WORD y=topMatrix.Get(b,n);
		if (y!=0xffff) matrix.Set(back[x],back[y],true);
	}}}

	for(y=0; y<matrix.GetSize(); y++) {
		for(x=0; x<matrix.GetSize(); x++)
			TRACE(" %d",(int)matrix.Get(x,y));
		TRACE("\n");
	}


#ifdef _DEBUG
/*	
	for(n=0; n<lsize;n++) TRACE("(%d.%d) ",list.GetAt(n).x,list.GetAt(n).y); TRACE("\n");
	TRACE("\ntop matrix\n");
	for(x=0; x<tsize; x++)
	{
		for(y=0; y<tsize; y++) TRACE("%d ",topMatrix.Get(x,y));
		TRACE("\n");
	}
	TRACE("\nnumbers\n");for(n=0; n<matrix->GetSize(); n++) TRACE("%d ",numbers[n]); TRACE("\n");
	TRACE("\nback\n");for(n=0; n<tsize; n++) TRACE("%d ",back[n]); TRACE("\n");
	TRACE("\nmask\n");for(n=0; n<tsize; n++) TRACE("%c ",'0'+mask[n]); TRACE("\n");
	TRACE("\nmatrix\n");
	for(x=0; x<matrix->GetSize(); x++)
	{
		for(y=0; y<matrix->GetSize(); y++) TRACE("%d ",(int)matrix->Get(x,y));
		TRACE("\n");
	}
	*/
#endif
	delete[](back);
	buffer=new(WORD[matrix.GetSize()]); MinColors=matrix.GetSize()+5;
	result=new(WORD[matrix.GetSize()]);
	FindSub(0);
	for(n=0; n<matrix.GetSize(); n++) graph->SetColor(numbers[n],result[n]);
	delete[]buffer; delete[]result;
	for(n=0; n<tsize; n++) {if(mask[n]==work) mask[n]=done;}
//	log_=&log->next;
	}
}

/*
//    
//               
//          
//           
//       ...       

WORD *Nucleus::MorphicDetector()
{
	int x,y,z,size; size=matrix->GetSize(); bool pass;
	struct item{WORD count; WORD number; WORD *list;}items*,temp;
	items=new item[size];
	for(x=0; x<size; x++) items[x].count=0,items[x].number=x;
	for(x=0; x<size; x++) for(y=x+1; y<size; y++) {if(matrix->Get(x,y)!=-1) items[x].count++,items[y].count++;}
	for(x=0; x<size; x++) {items[x].list=new WORD [items[x].count];
	for(y=z=0; y<size; y++) {if(matrix->Get(x,y)!=-1) items[x].list[z]=y;}}
	do{
		for(z=0; y<5; y++)
		{
			switch(z)
			{
			case 0: x=31; break;
			case 1: x=17; break;
			case 2: x=7; break;
			case 3: x=3; break;
			case 4: x=1; break;
			}
			pass=false;
			for(x=0; x+y<size; x++){
			if(items[x].count<items[x+y].count)
			{	pass=true; temp=items[x];
				items[x]=items[x+y]; items[x+y]=temp;
			}}
		}
	}while(pass);

}

*/
//[all][count][list.....][count][list......]