// OpenglSetup.cpp : implementation file
//

#include "stdafx.h"
#include "Color.h"
#include "OpenglSetup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// OpenglSetup dialog


OpenglSetup::OpenglSetup(CWnd* pParent /*=NULL*/)
	: CDialog(OpenglSetup::IDD, pParent)
{
	//{{AFX_DATA_INIT(OpenglSetup)
	m_fix = FALSE;
	m_x = 0;
	m_y = 0;
	m_mode = -1;
	m_magnify = 0;
	//}}AFX_DATA_INIT
}


void OpenglSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(OpenglSetup)
	DDX_Control(pDX, IDC_SLIDER2, m_wndSize2);
	DDX_Control(pDX, IDC_SLIDER1, m_wndSize1);
	DDX_Control(pDX, IDC_SPIN3, m_spin3);
	DDX_Control(pDX, IDC_SPIN2, m_spin2);
	DDX_Control(pDX, IDC_SPIN1, m_spin1);
	DDX_Check(pDX, IDC_CHECK, m_fix);
	DDX_Text(pDX, IDC_EDIT2, m_x);
	DDV_MinMaxInt(pDX, m_x, -1000, 1000);
	DDX_Text(pDX, IDC_EDIT3, m_y);
	DDV_MinMaxInt(pDX, m_y, -1000, 1000);
	DDX_Radio(pDX, IDC_RADIO1, m_mode);
	DDX_Control(pDX, IDC_BUTTON1, m_wndColor1);
	DDX_Control(pDX, IDC_BUTTON2, m_wndColor2);
	DDX_Slider(pDX,IDC_SLIDER1,m_size1);
	DDX_Slider(pDX,IDC_SLIDER2,m_size2);
	DDX_Text(pDX, IDC_EDIT1, m_magnify);
	DDV_MinMaxInt(pDX, m_magnify, 1, 1000);
	//}}AFX_DATA_MAP
	DDX_FODropColorButton(pDX,IDC_BUTTON1,color1);
	DDX_FODropColorButton(pDX,IDC_BUTTON2,color2);
	m_spin1.SetRange(1,1000);
	m_spin2.SetRange(-1000,1000);
	m_spin3.SetRange(-1000,1000);
	m_wndSize1.SetRange(1,TopSize*5);
	m_wndSize2.SetRange(1,TopSize*5);
}

BEGIN_MESSAGE_MAP(OpenglSetup, CDialog)
	//{{AFX_MSG_MAP(OpenglSetup)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// OpenglSetup message handlers

//DEL BOOL OpenglSetup::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
//DEL {
//DEL 	if(CDialog::Create(IDD, pParentWnd)) return -1;
//DEL 	return 0;
//DEL }
