// Nucleus.h: interface for the Nucleus class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NUCLEUS_H__72A47BE1_24AE_11D6_B8E2_444553540000__INCLUDED_)
#define AFX_NUCLEUS_H__72A47BE1_24AE_11D6_B8E2_444553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define FL_DIFFERENT 1
#define FL_ESTIMATION 2
#define FL_FIND_EQUAL 4
#define FL_FIND_NEQUAL 8
#include "Graph.h"
#include "SD.h"

namespace Report {
	struct NodeST {
		int color;
		int top;
		char type;
	};
//	enum reason{shoot,copy,chain};
	struct rootST {
		NodeST *root;
		int tops;
		int vars;
		int colors;
		int estimation;
	};
/*	struct ItemST {
		int tops;
		int links;
		int rulez1;	//    
		int rulze2;	//     ()
		int rulez3;	//  
		int rulez4;	//    
		int rulez5; //   
		int variants;	//  
		NodeST *tree;
		ContiguityMatrix Tmatrix;
		ContiguityMatrix Lmatrix;
		ItemST *next;
	};
*/
};


#define FLM_FIRST 1
#define FLM_FULL 2
#define FLM_OFF 4

class Nucleus  
{
public:
	void Start(Graph*);
	Nucleus();
	virtual ~Nucleus();
protected:
	BYTE Flags;
//	Report::ItemST *log;
	enum topStat{undef,work,done}*Tmask;
	enum morphCommand{install,uninstall,test,setup};
	struct morphHead{WORD sig; WORD capality; WORD count; BYTE flags;}morphSetup;
	struct morphRecord{WORD weight;WORD chc;WORD size;WORD tops;WORD* list;}*morphList;
	WORD morphNewCapality;

//	struct hs{int num;int sub; HeurReason reason;}; class c1:public CArray<hs,hs*>{}HeuristicsStack;

//	bool *on;
	int MinColors;	//  - 
	WORD *result;	//  
	WORD *numbers;	//      
	WORD *buffer;	//   
//	int estimate;	//   ( )
	Graph *graph;

	ContiguityMatrix matrix;	//  
	bool CMPpropert(int,int);
	void DelPropert();
	void Remove(int);
	void Estimate();
	void EstimateSub(int,int);
	void FindSub(int);
private:
	WORD * MorphicDetector();
};

#endif // !defined(AFX_NUCLEUS_H__72A47BE1_24AE_11D6_B8E2_444553540000__INCLUDED_)
