#if !defined(AFX_TMATRIX_H__96DE9DE1_2843_11D6_B8E2_F300C9156557__INCLUDED_)
#define AFX_TMATRIX_H__96DE9DE1_2843_11D6_B8E2_F300C9156557__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class ContiguityMatrix
{
public:
	ContiguityMatrix();
	ContiguityMatrix(WORD size,bool n=false);
	~ContiguityMatrix();
	void Install(WORD,bool n = false);
	void Set(WORD,WORD,bool);
	void Set(CPoint,bool);
	bool Get(WORD, WORD);
	int GetSize();
protected:
	BYTE *matrix;
	struct node{node *next1;node *next2;WORD x;WORD y;bool value;}*tree;
	int size; 
	void Uninstall();
	void TreeToMatrix(node *root);
	void SetByTree(WORD,WORD,bool);
	bool GetByTree(WORD,WORD);
	void *FindByTree(WORD,WORD,bool add=false);
	int nodeCount,nodeLimit;
	void MakeMatrix();
	void SetByMatrix(WORD,WORD,bool);
	bool GetByMatrix(WORD,WORD);
	bool def; 
};

class NumberMatrix
{
public:
	NumberMatrix();
	NumberMatrix(WORD size,BYTE n=-1);
	~NumberMatrix();
	void Install(WORD,BYTE n = -1);
	void Set(WORD,WORD,WORD);
	void Set(CPoint,WORD);
	WORD Get(WORD, WORD);
	int GetSize();
protected:
	WORD *matrix;
	struct node{node *next1;node *next2;WORD x;WORD y;WORD value;}*tree;
	void Uninstall();
	void TreeToMatrix(node *root);
	void SetByTree(WORD,WORD,WORD);
	WORD GetByTree(WORD,WORD);
	void *FindByTree(WORD,WORD,bool add=false);
	int nodeCount,nodeLimit;
	void MakeMatrix();
	void SetByMatrix(WORD,WORD,WORD);
	WORD GetByMatrix(WORD,WORD);
	WORD def; 
	int size; 
};

class BitMap
{
	BitMap(WORD);
	~BitMap();
	bool Get(WORD);
	void Set(WORD,bool);
	void Set(WORD);
	void Res(WORD);
	void Clear(); void Fill();
	WORD GetSize();
protected:
	BYTE *array;
	WORD size;
};


#endif // !defined(AFX_TMATRIX_H__96DE9DE1_2843_11D6_B8E2_F300C9156557__INCLUDED_)
