// stdafx.cpp : source file that includes just the standard includes
//	Color.pch will be the pre-compiled header
//	stdafx.obj will contain the pre-compiled type information

#include "stdafx.h"
#include "mmsystem.h"

UINT Play(void* n)
{
	return PlaySound((char*)n,0,SND_RESOURCE);
}

void Sound(int n)
{
	AfxBeginThread(Play,(void*)n);
}

DWORD ColorInterpolation(int from,int to,int min,int max,int r)
{
	DWORD ink=GetSysColor(to);
	BYTE c1=(BYTE)ink; BYTE b1=(BYTE)((ink>>8)&255); BYTE a1=(BYTE)(ink>>16);
	ink=GetSysColor(from);
	BYTE c2=(BYTE)ink; BYTE b2=(BYTE)((ink>>8)&255); BYTE a2=(BYTE)(ink>>16);
	a1=a2+(a1-a2)*(r-min)/(max-min);
	b1=b2+(b1-b2)*(r-min)/(max-min);
	c1=c2+(c1-c2)*(r-min)/(max-min);
	return RGB(a1,b1,c1);
}


void UpdateMenu(CCmdTarget * th,CMenu *pSubMenu)
{
	if (!pSubMenu) return;
	CCmdUI cmdUI;
	cmdUI.m_nIndexMax = pSubMenu->GetMenuItemCount();
	for (UINT n = 0; n < cmdUI.m_nIndexMax;n++)
	{
		cmdUI.m_nIndex = n;
		cmdUI.m_nID = pSubMenu->GetMenuItemID(n);
		cmdUI.m_pMenu = pSubMenu;
		cmdUI.DoUpdate(th, FALSE);
		UpdateMenu(th,pSubMenu->GetSubMenu(n));
	}
}


