// TEXsetup.cpp : implementation file
//

#include "stdafx.h"
#include "Color.h"
#include "TEXsetup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// TEXsetup dialog


TEXsetup::TEXsetup(CWnd* pParent /*=NULL*/)
	: CDialog(TEXsetup::IDD, pParent)
{
	//{{AFX_DATA_INIT(TEXsetup)
	m_inc = 0;
	m_dec = 0;
	m_numbers = FALSE;
	m_colors = FALSE;
	m_mode = -1;
	//}}AFX_DATA_INIT
}

const list[]={1,6,1,5,1,4,1,3,2,5,1,2,3,5,2,3,3,4,4,5,5,6,1,1,6,5,5,4,4,3,3,2,5,3,2,1,5,2,3,1,1,3,5,1,6,1};

void TEXsetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(TEXsetup)
	DDX_Control(pDX, IDC_COMBO, m_combo);
	DDX_Text(pDX, IDC_EDIT1, m_inc);
	DDV_MinMaxInt(pDX, m_inc, 1, 100);
	DDX_Text(pDX, IDC_EDIT2, m_dec);
	DDV_MinMaxInt(pDX, m_dec, 1, 100);
	DDX_Check(pDX, IDC_CHECK2, m_numbers);
	DDX_Check(pDX, IDC_CHECK3, m_colors);
	DDX_Radio(pDX, IDC_RADIO1, m_mode);
	//}}AFX_DATA_MAP
	CString add;
    for(int n=0; n<24; ) add.Format("%d : %d",list[n++],list[n++]),m_combo.AddString(add);
}


BEGIN_MESSAGE_MAP(TEXsetup, CDialog)
	//{{AFX_MSG_MAP(TEXsetup)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// TEXsetup message handlers

void TEXsetup::OnOK() 
{
	CDialog::OnOK(); int n; UpdateData(true);
	scaly1=scaly2=1;
	switch(m_mode)
	{
	case 0: n=m_combo.GetCurSel(); if(n<0) break;
		scaly1=list[n+n]; scaly2=list[n+n+1];
		break;
	case 1: scaly1=1; scaly2=m_inc; break;
	case 2: scaly1=m_dec; scaly2=1; break;
	}
}
