#if !defined(AFX_OPENGL_H__B653C963_3E92_11D6_B8E3_80D38074034C__INCLUDED_)
#define AFX_OPENGL_H__B653C963_3E92_11D6_B8E3_80D38074034C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// openGL.h : header file
//

#include "graph.h"

enum selectE{Torus,Skeleton,Spheres,Thorns};
struct OpenGLconfig{selectE SelectType;int BollSize; int LinkSize; DWORD BollColor; DWORD LinkColor;bool FixColor;};

/////////////////////////////////////////////////////////////////////////////
// openGL dialog

class openGL : public CDialog
{
// Construction
public:
	OpenGLconfig setup;
	openGL(Graph*,CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(openGL)
	enum { IDD = IDD_OPENGL };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(openGL)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	bool isAnimate;
	CPoint LastPoint;

	Graph *graph;  CPoint center;
	int m_xRotate;
	int m_yRotate;
	int m_zRotate;
	int m_xtRotate;
	int m_ytRotate;
	int m_xOffset;
	int m_yOffset;
	CPoint pullPoint;

	bool SetWindowPixelFormat(HDC hDC);
	bool CreateViewGLContext(HDC hDC);
	void BuildList();
	void RenderScene();
	void OnNcClick(UINT nHitTest, CPoint point,bool doub);

	HGLRC m_hGLContext;
	int m_GLPixelIndex;
	float m_Scale_;
	float m_Scale;
	int CurrentTop;
	enum {move,rotate}MouseMode;

	// Generated message map functions
	//{{AFX_MSG(openGL)
	afx_msg void OnPaint();
	afx_msg void OnNcPaint();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnNcLButtonDown( UINT nHitTest, CPoint point );
	afx_msg void OnNcLButtonDblClk( UINT nHitTest, CPoint point );
	afx_msg void OnAnimate();
	afx_msg void OnSelect1();
	afx_msg void OnSelect2();
	afx_msg void OnSelect3();
	afx_msg void OnSelect4();
	afx_msg void OnUpdateAnimate(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSel1(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSel2(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSel3(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSel4(CCmdUI* pCmdUI);
	afx_msg void OnSetup();
	afx_msg void OnResetXy();
	afx_msg void OnResetSelect();
	afx_msg void OnResetScaly();
	afx_msg void OnResetAngle();
	afx_msg void OnMouseMove1();
	afx_msg void OnUpdateMouseMove(CCmdUI* pCmdUI);
	afx_msg void OnMouseRotate();
	afx_msg void OnUpdateMouseRotate(CCmdUI* pCmdUI);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnReduce();
	afx_msg void OnNext();
	afx_msg void OnMagnify();
	afx_msg void OnBack();
	afx_msg void OnNormalSize();
	afx_msg void OnUpdateNormalSize(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPENGL_H__B653C963_3E92_11D6_B8E3_80D38074034C__INCLUDED_)
